using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using System.Reflection;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class GEN_ImpuestosLineas_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada,long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 10;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.id) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoTipo) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.impuesto) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.recargo) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Imp_Compras) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Imp_Ventas) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Rec_Ventas) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Rec_Compras) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Compras) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idDepartamento) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idEmpresa) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaDesde) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaHasta) + "," +
                      nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) +
                  " FROM " + nameof(GEN_ImpuestosLineas) +
                  " WHERE " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) + " IS NULL AND " +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<GEN_ImpuestosLineas>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //GEN_ImpuestosCabecera ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idImpuestoCabecera != null)
                    {
                        ThreadStart obj_ThreadStart_IMPUESTOCABECERA = new ThreadStart(Obtener_ImpuestoCabecera_Modelo_Obtener);
                        Thread obj_Thread_IMPUESTOCABECERA = new Thread(obj_ThreadStart_IMPUESTOCABECERA);
                        obj_Thread_IMPUESTOCABECERA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //GEN_ImpuestosTipos ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idImpuestoTipo != null)
                    {
                        ThreadStart obj_ThreadStart_IMPUESTOTIPO = new ThreadStart(Obtener_ImpuestoTipo_Modelo_Obtener);
                        Thread obj_Thread_IMPUESTOTIPO = new Thread(obj_ThreadStart_IMPUESTOTIPO);
                        obj_Thread_IMPUESTOTIPO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //CTA_Mayor (Impuesto Compras) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_Imp_Compras != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORIMPUESTOCOMPRAS = new ThreadStart(Obtener_MayorImpuestoCompras_Modelo_Obtener);
                        Thread obj_Thread_MAYORIMPUESTOCOMPRAS = new Thread(obj_ThreadStart_MAYORIMPUESTOCOMPRAS);
                        obj_Thread_MAYORIMPUESTOCOMPRAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }

                    //CTA_Mayor (Impuesto Ventas) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_Imp_Ventas != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORIMPUESTOVENTAS = new ThreadStart(Obtener_MayorImpuestoVentas_Modelo_Obtener);
                        Thread obj_Thread_MAYORIMPUESTOVENTAS = new Thread(obj_ThreadStart_MAYORIMPUESTOVENTAS);
                        obj_Thread_MAYORIMPUESTOVENTAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[3] = true;
                    }

                    //CTA_Mayor (Recargo Ventas) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_Rec_Ventas != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORRECARGOVENTAS = new ThreadStart(Obtener_MayorRecargoVentas_Modelo_Obtener);
                        Thread obj_Thread_MAYORRECARGOVENTAS = new Thread(obj_ThreadStart_MAYORRECARGOVENTAS);
                        obj_Thread_MAYORRECARGOVENTAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[4] = true;
                    }

                    //CTA_Mayor (BaseImponible Ventas) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_BaseImponible_Ventas != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORBASEIMPONIBLEVENTAS = new ThreadStart(Obtener_MayorBaseImponibleVentas_Modelo_Obtener);
                        Thread obj_Thread_MAYORBASEIMPONIBLEVENTAS = new Thread(obj_ThreadStart_MAYORBASEIMPONIBLEVENTAS);
                        obj_Thread_MAYORBASEIMPONIBLEVENTAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[5] = true;
                    }

                    //CTA_Mayor (BaseImponible Compras) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_BaseImponible_Compras != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORBASEIMPONIBLECOMPRAS = new ThreadStart(Obtener_MayorBaseImponibleCompras_Modelo_Obtener);
                        Thread obj_Thread_MAYORBASEIMPONIBLECOMPRAS = new Thread(obj_ThreadStart_MAYORBASEIMPONIBLECOMPRAS);
                        obj_Thread_MAYORBASEIMPONIBLECOMPRAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[6] = true;
                    }
                    
                    //CTA_Departamento ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idDepartamento != null)
                    {
                        ThreadStart obj_ThreadStart_DEPARTAMENTO = new ThreadStart(Obtener_Departamento_Modelo_Obtener);
                        Thread obj_Thread_DEPARTAMENTO = new Thread(obj_ThreadStart_DEPARTAMENTO);
                        obj_Thread_DEPARTAMENTO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[7] = true;
                    }

                    //GEN_Empresas  ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpresa != null)
                    {
                        ThreadStart obj_ThreadStart_EMPRESA = new ThreadStart(Obtener_Empresa_Modelo_Obtener);
                        Thread obj_Thread_EMPRESA = new Thread(obj_ThreadStart_EMPRESA);
                        obj_Thread_EMPRESA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[8] = true;
                    }

                    //CTA_Mayor (Recargo Compras) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor_Rec_Compras != null)
                    {
                        ThreadStart obj_ThreadStart_MAYORRECARGOCOMPRAS = new ThreadStart(Obtener_MayorRecargoCompras_Modelo_Obtener);
                        Thread obj_Thread_MAYORRECARGOCOMPRAS = new Thread(obj_ThreadStart_MAYORRECARGOCOMPRAS);
                        obj_Thread_MAYORRECARGOCOMPRAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[9] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_ImpuestoCabecera_Modelo_Obtener()
        {
            try
            {
                GEN_ImpuestosCabecera_Datos obj_GEN_ImpuestosCabecera_Datos = new GEN_ImpuestosCabecera_Datos();
                g_dnm_Modelo_Obtener.GEN_ImpuestosCabecera = obj_GEN_ImpuestosCabecera_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idImpuestoCabecera,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_ImpuestoTipo_Modelo_Obtener()
        {
            try
            {
                GEN_ImpuestosTipos_Datos obj_GEN_ImpuestosTipos_Datos = new GEN_ImpuestosTipos_Datos();
                g_dnm_Modelo_Obtener.GEN_ImpuestosTipos = obj_GEN_ImpuestosTipos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idImpuestoTipo);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_MayorImpuestoCompras_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_Imp_Compras };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        private void Obtener_MayorImpuestoVentas_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_Imp_Ventas };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor1 = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[3] = true;
            }
        }
        private void Obtener_MayorRecargoVentas_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_Rec_Ventas };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor2 = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[4] = true;
            }
        }
        private void Obtener_MayorBaseImponibleVentas_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_BaseImponible_Ventas };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor3 = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[5] = true;
            }
        }
        private void Obtener_MayorBaseImponibleCompras_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_BaseImponible_Compras };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor4 = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[6] = true;
            }
        }
        private void Obtener_Departamento_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTADEPARTAMENTO_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idDepartamento };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Departamentos = (CTA_Departamentos)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[7] = true;
            }
        }
        private void Obtener_Empresa_Modelo_Obtener()
        {
            try
            {
                GEN_Empresas_Datos obj_GEN_Empresas_Datos = new GEN_Empresas_Datos();
                g_dnm_Modelo_Obtener.GEN_Empresas = obj_GEN_Empresas_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmpresa,false,false,false,false);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[8] = true;
            }
        }
        private void Obtener_MayorRecargoCompras_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idMayor_Rec_Compras };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.CTA_Mayor2 = (CTA_Mayor)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[9] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public bool Existe_Registro_PorFecha(long _lng_idImpuestoCabecera,long _lng_idImpuestoTipo,DateTime _dtt_Fecha)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas = null;
            bool bol_Existe = false;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.id) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoTipo) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.impuesto) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.recargo) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Imp_Compras) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Imp_Ventas) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Rec_Ventas) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_Rec_Compras) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Compras) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idDepartamento) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idEmpresa) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaDesde) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaHasta) + "," +
                              nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) +
                        " FROM " + nameof(GEN_ImpuestosLineas) +
                        " INNER JOIN " + nameof(GEN_ImpuestosCabecera) + " ON " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + " = " + nameof(GEN_ImpuestosCabecera) + "." + nameof(GEN_ImpuestosCabecera.id) +
                        " INNER JOIN " + nameof(GEN_ImpuestosTipos) + " ON " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoTipo) + " = " + nameof(GEN_ImpuestosTipos) + "." + nameof(GEN_ImpuestosTipos.id) +
                        " WHERE  " + nameof(GEN_ImpuestosCabecera) + "." + nameof(GEN_ImpuestosCabecera.fechaBorrado) + " IS NULL AND " +
                                     nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) + " IS null AND " +
                                     nameof(GEN_ImpuestosTipos) + "." + nameof(GEN_ImpuestosTipos.fechaBorrado) + " IS null AND " +
                                     nameof(GEN_ImpuestosCabecera) + "." + nameof(GEN_ImpuestosCabecera.id) + "=@idImpuestoCabecera AND " +
                                     " (NOT " + nameof(GEN_ImpuestosTipos) + "." + nameof(GEN_ImpuestosTipos.id) + " IS null) AND " +
                                     nameof(GEN_ImpuestosTipos) + "." + nameof(GEN_ImpuestosTipos.id) + "=@idImpuestoTipo AND " +
                                     nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaDesde) + " <=@fechaDesde AND " +
                                     "( " +
                                        " ( " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaHasta) + " IS NULL) " + 
                                        " OR " +
                                        " ( " + 
                                            " ( NOT " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaHasta) + " IS NULL) AND " +
                                            " ( " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaHasta) +">=@fechaHasta ) " +
                                        " ) " +
                                     " ) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idImpuestoCabecera",  _lng_idImpuestoCabecera),
                     new SqlParameter("@idImpuestoTipo",  _lng_idImpuestoTipo),
                     new SqlParameter("@fechaDesde",  _dtt_Fecha),
                     new SqlParameter("@fechaHasta",  _dtt_Fecha)
                };

                //Rellenar el Modelo
                mdl_GEN_ImpuestosLineas = obj_Exferia_Entities.Database.SqlQuery<GEN_ImpuestosLineas>(str_SQL, arr_Parametros).FirstOrDefault();

                if(mdl_GEN_ImpuestosLineas != null )
                {
                    bol_Existe = true;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Existe_Registro_PorFecha), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return bol_Existe;
        }

        #endregion

        #region MODELOS

        #region Modelos Simple
        private GEN_ImpuestosLineas g_mdl_GEN_ImpuestosLineas = null;

        public GEN_ImpuestosLineas Obtener_Modelo_Por_Id(long _lng_Id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " +
                                   nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_Id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                        arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_GEN_ImpuestosLineas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_GEN_ImpuestosLineas = obj_Exferia_Entities.Database.SqlQuery<GEN_ImpuestosLineas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<GEN_ImpuestosLineas> g_lst_GEN_ImpuestosLineas = null;

        public List<GEN_ImpuestosLineas> Obtener_ModeloListado_Por_IdImpuestoCabecera(List<long> _lst_idImpuestoCabecera)
        {
            try
            {

                if (_lst_idImpuestoCabecera != null && _lst_idImpuestoCabecera.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(GEN_ImpuestosLineas),
                                                                                            nameof(GEN_ImpuestosLineas.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_idImpuestoCabecera);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE  " + 
                                            nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) + " IS null and " +
                                            str_Filtros_IDS;




                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[]{},
                                                     false,
                                                     false,
                                                     false,
                                                     false,
                                                     false,
                                                     false,
                                                     false,
                                                     false);
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdImpuestoCabecera), true);
            }

            return g_lst_GEN_ImpuestosLineas;
        }

        public List<GEN_ImpuestosLineas> Obtener_ModeloListado_Por_IdImpuestoCabecera(long _lng_idImpuestoCabecera,
                                                                                      bool _bol_Cargar_MayorImpuestoCompra,
                                                                                      bool _bol_Cargar_MayorImpuestoVenta,
                                                                                      bool _bol_Cargar_MayorRecargoVentas,
                                                                                      bool _bol_Cargar_MayorBaseImponibleVentas,
                                                                                      bool _bol_Cargar_MayorBaseImponibleCompras,
                                                                                      bool _bol_Cargar_Departamento,
                                                                                      bool _bol_Cargar_MayorRecargoCompras)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.fechaBorrado) + " IS null AND " +
                                                nameof(GEN_ImpuestosLineas) + "." + nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "=@idImpuestoCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idImpuestoCabecera",  _lng_idImpuestoCabecera)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_MayorImpuestoCompra,
                                                 _bol_Cargar_MayorImpuestoVenta,
                                                 _bol_Cargar_MayorRecargoVentas,
                                                 _bol_Cargar_MayorBaseImponibleVentas,
                                                 _bol_Cargar_MayorBaseImponibleCompras,
                                                 _bol_Cargar_Departamento,
                                                 _bol_Cargar_MayorRecargoCompras,
                                                 true);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdImpuestoCabecera), true);
            }

            return g_lst_GEN_ImpuestosLineas;
        }

        #region Ejecutar consulta
        //Listado de modelos Relacionados
        private List<CTA_Mayor> g_lst_CTA_Mayores = null;
        private List<long> g_lst_Mayores = null;
        private List<CTA_Departamentos> g_lst_CTA_Departamentos = null;
        private List<GEN_ImpuestosTipos> g_lst_GEN_ImpuestosTipos = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 3;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_MayorImpuestoCompra,
                                                      bool _bol_Cargar_MayorImpuestoVenta,
                                                      bool _bol_Cargar_MayorRecargoVentas,
                                                      bool _bol_Cargar_MayorBaseImponibleVentas,
                                                      bool _bol_Cargar_MayorBaseImponibleCompras,
                                                      bool _bol_Cargar_Departamento,
                                                      bool _bol_Cargar_MayorRecargoCompras,
                                                      bool _bol_Cargar_ImpuestoTipo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_GEN_ImpuestosLineas = obj_Exferia_Entities.Database.SqlQuery<GEN_ImpuestosLineas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar Tablas Relacionadas
                if (g_lst_GEN_ImpuestosLineas != null && g_lst_GEN_ImpuestosLineas.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_MayorImpuestoCompra ||
                        _bol_Cargar_MayorImpuestoVenta ||
                        _bol_Cargar_MayorRecargoVentas ||
                        _bol_Cargar_MayorBaseImponibleVentas ||
                        _bol_Cargar_MayorBaseImponibleCompras ||
                        _bol_Cargar_MayorRecargoCompras||
                        _bol_Cargar_Departamento ||
                        _bol_Cargar_ImpuestoTipo)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        g_lst_Mayores = new List<long>();

                        //CTA_Mayor(Impuesto Compra) #############################################
                        if (_bol_Cargar_MayorImpuestoCompra)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_Imp_Compras != null).Select(m => m.idMayor_Imp_Compras.Value).ToList());
                        }

                        //CTA_Mayor(Impuesto Venta) #############################################
                        if (_bol_Cargar_MayorImpuestoVenta)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_Imp_Ventas != null).Select(m => m.idMayor_Imp_Ventas.Value).ToList());
                        }

                        //CTA_Mayor(Recargo VEnta) #############################################
                        if (_bol_Cargar_MayorRecargoVentas)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_Rec_Ventas != null).Select(m => m.idMayor_Rec_Ventas.Value).ToList());
                        }

                        //CTA_Mayor(Recargo Compra) #############################################
                        if (_bol_Cargar_MayorRecargoCompras)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_Rec_Compras != null).Select(m => m.idMayor_Rec_Compras.Value).ToList());
                        }

                        //CTA_Mayor(BaseImponible Ventas) #############################################
                        if (_bol_Cargar_MayorBaseImponibleVentas)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_BaseImponible_Ventas != null).Select(m => m.idMayor_BaseImponible_Ventas.Value).ToList());
                        }

                        //CTA_Mayor(BaseImponible Compras) #############################################
                        if (_bol_Cargar_MayorBaseImponibleCompras)
                        {
                            g_lst_Mayores.AddRange(g_lst_GEN_ImpuestosLineas.Where(m => m.idMayor_BaseImponible_Compras != null).Select(m => m.idMayor_BaseImponible_Compras.Value).ToList());
                        }

                        //Mayores
                        if (g_lst_Mayores.Count > 0)
                        {
                            ThreadStart obj_ThreadStart_MAYORES = new ThreadStart(Obtener_Mayores_Modelo_Listado);
                            Thread obj_Thread_MAYORES = new Thread(obj_ThreadStart_MAYORES);
                            obj_Thread_MAYORES.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //CTA_Departamentos #############################################
                        if (_bol_Cargar_ImpuestoTipo)
                        {
                            ThreadStart obj_ThreadStart_DEPARTAMENTO = new ThreadStart(Obtener_Departamento_Modelo_Listado);
                            Thread obj_Thread_DEPARTAMENTO = new Thread(obj_ThreadStart_DEPARTAMENTO);
                            obj_Thread_DEPARTAMENTO.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
                        }

                        //GEN_ImpuestosTipos #############################################
                        ThreadStart obj_ThreadStart_IMPUESTOTIPO = new ThreadStart(Obtener_ImpuestoTipo_Modelo_Listado);
                        Thread obj_Thread_IMPUESTOTIPO = new Thread(obj_ThreadStart_IMPUESTOTIPO);
                        obj_Thread_IMPUESTOTIPO.Start();
                        
                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas in g_lst_GEN_ImpuestosLineas)
                        {
                            //CTA_MAYOR(Impuesto Compras) #############################################
                            if (_bol_Cargar_MayorImpuestoCompra &&
                                mdl_GEN_ImpuestosLineas.idMayor_Imp_Compras!= null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_Imp_Compras.Value).FirstOrDefault();
                            }

                            //CTA_MAYOR(Impuesto Ventas) #############################################
                            if (_bol_Cargar_MayorImpuestoVenta &&
                                mdl_GEN_ImpuestosLineas.idMayor_Imp_Ventas != null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor1 = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_Imp_Ventas.Value).FirstOrDefault();
                            }

                            //CTA_MAYOR(Recargo Ventas) #############################################
                            if (_bol_Cargar_MayorRecargoVentas &&
                                mdl_GEN_ImpuestosLineas.idMayor_Rec_Ventas != null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor2 = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_Rec_Ventas.Value).FirstOrDefault();
                            }

                            //CTA_MAYOR(Base Imponible Ventas) #############################################
                            if (_bol_Cargar_MayorBaseImponibleVentas &&
                                mdl_GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas != null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor3 = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas.Value).FirstOrDefault();
                            }

                            //CTA_MAYOR(Base Imponible Compras) #############################################
                            if (_bol_Cargar_MayorBaseImponibleCompras &&
                                mdl_GEN_ImpuestosLineas.idMayor_BaseImponible_Compras != null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor4 = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_BaseImponible_Compras.Value).FirstOrDefault();
                            }

                            //CTA_MAYOR(Recargo Compras) #############################################
                            if (_bol_Cargar_MayorRecargoCompras &&
                                mdl_GEN_ImpuestosLineas.idMayor_Rec_Compras != null &&
                                g_lst_CTA_Mayores != null &&
                                g_lst_CTA_Mayores.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Mayor5 = g_lst_CTA_Mayores.Where(m => m.id == mdl_GEN_ImpuestosLineas.idMayor_Rec_Compras.Value).FirstOrDefault();
                            }

                            //CTA_Departamento #############################################
                            if (_bol_Cargar_Departamento &&
                                mdl_GEN_ImpuestosLineas.idDepartamento != null &&
                                g_lst_CTA_Departamentos != null &&
                                g_lst_CTA_Departamentos.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.CTA_Departamentos = g_lst_CTA_Departamentos.Where(m => m.id == mdl_GEN_ImpuestosLineas.idDepartamento.Value).FirstOrDefault();
                            }

                            //GEN_ImpuestosTipos #############################################
                            if (mdl_GEN_ImpuestosLineas.idImpuestoTipo != null &&
                                g_lst_GEN_ImpuestosTipos != null &&
                                g_lst_GEN_ImpuestosTipos.Count > 0)
                            {
                                mdl_GEN_ImpuestosLineas.GEN_ImpuestosTipos = g_lst_GEN_ImpuestosTipos.Where(m => m.id == mdl_GEN_ImpuestosLineas.idImpuestoTipo.Value).FirstOrDefault();
                            }

                        }
                        #endregion

                    }
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Mayores_Modelo_Listado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTAMAYOR_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_lst_Mayores };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_CTA_Mayores = (List<CTA_Mayor>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_Departamento_Modelo_Listado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_CONTABILIDAD + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_CONTABILIDAD + "." + Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSCONTABILIDAD_PROCEDIMIENTO_CTADEPARTAMENTO_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_lst_GEN_ImpuestosLineas.Where(m => m.idDepartamento != null).Select(m => m.idDepartamento.Value).ToList() };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_CTA_Departamentos = (List<CTA_Departamentos>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        private void Obtener_ImpuestoTipo_Modelo_Listado()
        {
            try
            {
                GEN_ImpuestosTipos_Datos obj_GEN_ImpuestosTipos_Datos = new GEN_ImpuestosTipos_Datos();
                g_lst_GEN_ImpuestosTipos = obj_GEN_ImpuestosTipos_Datos.Obtener_ModeloListado_Por_Ids(g_lst_GEN_ImpuestosLineas.Where(m => m.idImpuestoTipo != null).Select(m => m.idImpuestoTipo.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[2] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(GEN_ImpuestosLineas.id) + "," +
                    nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "," +
                    nameof(GEN_ImpuestosLineas.idImpuestoTipo) + "," +
                    nameof(GEN_ImpuestosLineas.impuesto) + "," +
                    nameof(GEN_ImpuestosLineas.recargo) + "," +
                    nameof(GEN_ImpuestosLineas.idMayor_Imp_Compras) + "," +
                    nameof(GEN_ImpuestosLineas.idMayor_Imp_Ventas) + "," +
                    nameof(GEN_ImpuestosLineas.idMayor_Rec_Ventas) + "," +
                     nameof(GEN_ImpuestosLineas.idMayor_Rec_Compras) + "," +
                    nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas) + "," +
                    nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Compras) + "," +
                    nameof(GEN_ImpuestosLineas.idDepartamento) + "," +
                    nameof(GEN_ImpuestosLineas.idEmpresa) + "," +
                    nameof(GEN_ImpuestosLineas.fechaDesde) + "," +
                    nameof(GEN_ImpuestosLineas.fechaHasta) + "," +
                    nameof(GEN_ImpuestosLineas.fechaBorrado) +
                " FROM " + nameof(GEN_ImpuestosLineas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas_AGrabar = (GEN_ImpuestosLineas)_mdl_obj;
                GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas_DatosViejos = new GEN_ImpuestosLineas();

                // Ver si existe ######################################################################
                GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas_Final = Obtener_Modelo_Por_Id(mdl_GEN_ImpuestosLineas_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_GEN_ImpuestosLineas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_ImpuestosLineas_Final, mdl_GEN_ImpuestosLineas_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la Trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_ImpuestosLineas_AGrabar, mdl_GEN_ImpuestosLineas_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_ImpuestosLineas) +
                                            " SET " +
                                                nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "=@idImpuestoCabecera," +
                                                nameof(GEN_ImpuestosLineas.idImpuestoTipo) + "=@idImpuestoTipo," +
                                                nameof(GEN_ImpuestosLineas.impuesto) + "=@impuesto," +
                                                nameof(GEN_ImpuestosLineas.recargo) + "=@recargo," +
                                                nameof(GEN_ImpuestosLineas.idMayor_Imp_Compras) + "=@idMayor_Imp_Compras," +
                                                nameof(GEN_ImpuestosLineas.idMayor_Imp_Ventas) + "=@idMayor_Imp_Ventas," +
                                                nameof(GEN_ImpuestosLineas.idMayor_Rec_Ventas) + "=@idMayor_Rec_Ventas," +
                                                nameof(GEN_ImpuestosLineas.idMayor_Rec_Compras) + "=@idMayor_Rec_Compras," +
                                                nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas) + "=@idMayor_BaseImponible_Ventas," +
                                                nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Compras) + "=@idMayor_BaseImponible_Compras," +
                                                nameof(GEN_ImpuestosLineas.idDepartamento) + "=@idDepartamento," +
                                                nameof(GEN_ImpuestosLineas.idEmpresa) + "=@idEmpresa," +
                                                nameof(GEN_ImpuestosLineas.fechaDesde) + "=@fechaDesde," +
                                                nameof(GEN_ImpuestosLineas.fechaHasta) + "=@fechaHasta," +
                                                nameof(GEN_ImpuestosLineas.fechaBorrado) + "=@fechaBorrado" +
                                            " WHERE " +
                                                nameof(GEN_ImpuestosLineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_GEN_ImpuestosLineas_Final.idImpuestoCabecera != null
                            ?   new SqlParameter("@idImpuestoCabecera", mdl_GEN_ImpuestosLineas_Final.idImpuestoCabecera.Value)
                            :   new SqlParameter("@idImpuestoCabecera",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idImpuestoTipo != null
                            ?   new SqlParameter("@idImpuestoTipo", mdl_GEN_ImpuestosLineas_Final.idImpuestoTipo.Value)
                            :   new SqlParameter("@idImpuestoTipo",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.impuesto != null
                            ?   new SqlParameter("@impuesto", mdl_GEN_ImpuestosLineas_Final.impuesto.Value)
                            :   new SqlParameter("@impuesto",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.recargo != null
                            ?   new SqlParameter("@recargo", mdl_GEN_ImpuestosLineas_Final.recargo.Value)
                            :   new SqlParameter("@recargo",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Compras != null
                            ?   new SqlParameter("@idMayor_Imp_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Compras.Value)
                            :   new SqlParameter("@idMayor_Imp_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Ventas != null
                            ?   new SqlParameter("@idMayor_Imp_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Ventas.Value)
                            :   new SqlParameter("@idMayor_Imp_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Ventas != null
                            ?   new SqlParameter("@idMayor_Rec_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Ventas.Value)
                            :   new SqlParameter("@idMayor_Rec_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Compras != null
                            ?   new SqlParameter("@idMayor_Rec_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Compras.Value)
                            :   new SqlParameter("@idMayor_Rec_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Compras != null
                            ?   new SqlParameter("@idMayor_BaseImponible_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Compras.Value)
                            :   new SqlParameter("@idMayor_BaseImponible_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Ventas != null
                            ?   new SqlParameter("@idMayor_BaseImponible_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Ventas.Value)
                            :   new SqlParameter("@idMayor_BaseImponible_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idDepartamento != null
                            ?   new SqlParameter("@idDepartamento", mdl_GEN_ImpuestosLineas_Final.idDepartamento.Value)
                            :   new SqlParameter("@idDepartamento",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idEmpresa != null
                            ?   new SqlParameter("@idEmpresa", mdl_GEN_ImpuestosLineas_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                        new SqlParameter("@fechaDesde",  mdl_GEN_ImpuestosLineas_Final.fechaDesde),
                        mdl_GEN_ImpuestosLineas_Final.fechaHasta != null
                            ?   new SqlParameter("@fechaHasta", mdl_GEN_ImpuestosLineas_Final.fechaHasta.Value)
                            :   new SqlParameter("@fechaHasta",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_ImpuestosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id", mdl_GEN_ImpuestosLineas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_GEN_ImpuestosLineas_Final.id;
                }
                //INSERT
                else
                {
                    mdl_GEN_ImpuestosLineas_Final = new GEN_ImpuestosLineas();

                    //Tipo de Accdion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_ImpuestosLineas_AGrabar, mdl_GEN_ImpuestosLineas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GEN_ImpuestosLineas) +
                                                " (" +
                                                        nameof(GEN_ImpuestosLineas.idImpuestoCabecera) + "," +
                                                        nameof(GEN_ImpuestosLineas.idImpuestoTipo) + "," +
                                                        nameof(GEN_ImpuestosLineas.impuesto) + "," +
                                                        nameof(GEN_ImpuestosLineas.recargo) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_Imp_Compras) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_Imp_Ventas) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_Rec_Ventas) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_Rec_Compras) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Ventas) + "," +
                                                        nameof(GEN_ImpuestosLineas.idMayor_BaseImponible_Compras) + "," +
                                                        nameof(GEN_ImpuestosLineas.idDepartamento) + "," +
                                                        nameof(GEN_ImpuestosLineas.idEmpresa) + "," +
                                                        nameof(GEN_ImpuestosLineas.fechaDesde) + "," +
                                                        nameof(GEN_ImpuestosLineas.fechaHasta) + "," +
                                                        nameof(GEN_ImpuestosLineas.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(GEN_ImpuestosLineas.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idImpuestoCabecera," +
                                                    "@idImpuestoTipo," +
                                                    "@impuesto," +
                                                    "@recargo," +
                                                    "@idMayor_Imp_Compras," +
                                                    "@idMayor_Imp_Ventas," +
                                                    "@idMayor_Rec_Ventas," +
                                                    "@idMayor_Rec_Compras," +
                                                    "@idMayor_BaseImponible_Ventas," +
                                                    "@idMayor_BaseImponible_Compras," +
                                                    "@idDepartamento," +
                                                    "@idEmpresa," +
                                                    "@fechaDesde," +
                                                    "@fechaHasta," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        mdl_GEN_ImpuestosLineas_Final.idImpuestoCabecera != null
                            ?   new SqlParameter("@idImpuestoCabecera", mdl_GEN_ImpuestosLineas_Final.idImpuestoCabecera.Value)
                            :   new SqlParameter("@idImpuestoCabecera",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idImpuestoTipo != null
                            ?   new SqlParameter("@idImpuestoTipo", mdl_GEN_ImpuestosLineas_Final.idImpuestoTipo.Value)
                            :   new SqlParameter("@idImpuestoTipo",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.impuesto != null
                            ?   new SqlParameter("@impuesto", mdl_GEN_ImpuestosLineas_Final.impuesto.Value)
                            :   new SqlParameter("@impuesto",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.recargo != null
                            ?   new SqlParameter("@recargo", mdl_GEN_ImpuestosLineas_Final.recargo.Value)
                            :   new SqlParameter("@recargo",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Compras != null
                            ?   new SqlParameter("@idMayor_Imp_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Compras.Value)
                            :   new SqlParameter("@idMayor_Imp_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Ventas != null
                            ?   new SqlParameter("@idMayor_Imp_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_Imp_Ventas.Value)
                            :   new SqlParameter("@idMayor_Imp_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Ventas != null
                            ?   new SqlParameter("@idMayor_Rec_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Ventas.Value)
                            :   new SqlParameter("@idMayor_Rec_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Compras != null
                            ?   new SqlParameter("@idMayor_Rec_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_Rec_Compras.Value)
                            :   new SqlParameter("@idMayor_Rec_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Compras != null
                            ?   new SqlParameter("@idMayor_BaseImponible_Compras", mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Compras.Value)
                            :   new SqlParameter("@idMayor_BaseImponible_Compras",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Ventas != null
                            ?   new SqlParameter("@idMayor_BaseImponible_Ventas", mdl_GEN_ImpuestosLineas_Final.idMayor_BaseImponible_Ventas.Value)
                            :   new SqlParameter("@idMayor_BaseImponible_Ventas",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idDepartamento != null
                            ?   new SqlParameter("@idDepartamento", mdl_GEN_ImpuestosLineas_Final.idDepartamento.Value)
                            :   new SqlParameter("@idDepartamento",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.idEmpresa != null
                            ?   new SqlParameter("@idEmpresa", mdl_GEN_ImpuestosLineas_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                        new SqlParameter("@fechaDesde",  mdl_GEN_ImpuestosLineas_Final.fechaDesde),
                        mdl_GEN_ImpuestosLineas_Final.fechaHasta != null
                            ?   new SqlParameter("@fechaHasta", mdl_GEN_ImpuestosLineas_Final.fechaHasta.Value)
                            :   new SqlParameter("@fechaHasta",  DBNull.Value),
                        mdl_GEN_ImpuestosLineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_ImpuestosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_ImpuestosLineas), mdl_GEN_ImpuestosLineas_DatosViejos, mdl_GEN_ImpuestosLineas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
           
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GEN_ImpuestosLineas mdl_GEN_ImpuestosLineas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_GEN_ImpuestosLineas_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_ImpuestosLineas) +
                                                " SET " +
                                                nameof(GEN_ImpuestosLineas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(GEN_ImpuestosLineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_ImpuestosLineas), null, mdl_GEN_ImpuestosLineas_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_ImpuestosLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
